-- Fredzaza --

AnimRenaultD320 = {};
AnimRenaultD320.ModDirectory = g_currentModDirectory

function AnimRenaultD320.prerequisitesPresent(specializations)
      return true;
end;
function AnimRenaultD320.initSpecialization()
end
function AnimRenaultD320.registerOverwrittenFunctions(vehicleType)
end
function AnimRenaultD320.registerFunctions(vehicleType)	
end
function AnimRenaultD320.registerEvents(vehicleType)
end
function AnimRenaultD320:registerActionEventsPlayer()
end
function AnimRenaultD320:registerActionEventsMenu()
end

function AnimRenaultD320:onRegisterActionEvents(isSelected, isOnActiveVehicle)
	if isOnActiveVehicle then
		if self.AnimRenaultD320 == nil then 
			self.AnimRenaultD320 = {}
		else	
			self:clearActionEventsTable( self.AnimRenaultD320 )
		end 
		for _,actionName in pairs({"ridelle_G_RD320_v1", "ridelle_D_RD320_v1"}) do
			local _, eventName = self:addActionEvent(self.AnimRenaultD320, InputAction[actionName], self, AnimRenaultD320.actionCallback, true, true, false, true, nil);
	
			if isSelected then
				g_inputBinding.events[eventName].displayPriority = 1
			elseif  isOnActiveVehicle then
				g_inputBinding.events[eventName].displayPriority = 3
			end
		end
	end
end

function AnimRenaultD320.registerEventListeners(vehicleType)
	SpecializationUtil.registerEventListener(vehicleType, "onLoad", AnimRenaultD320)
	SpecializationUtil.registerEventListener(vehicleType, "onDelete", AnimRenaultD320)
    SpecializationUtil.registerEventListener(vehicleType, "onReadStream", AnimRenaultD320)
    SpecializationUtil.registerEventListener(vehicleType, "onWriteStream", AnimRenaultD320)
    --SpecializationUtil.registerEventListener(vehicleType, "onReadUpdateStream", AnimRenaultD320)
    --SpecializationUtil.registerEventListener(vehicleType, "onWriteUpdateStream", AnimRenaultD320)
	SpecializationUtil.registerEventListener(vehicleType, "onUpdate", AnimRenaultD320)
	SpecializationUtil.registerEventListener(vehicleType, "onDraw", AnimRenaultD320)
	SpecializationUtil.registerEventListener(vehicleType, "onRegisterActionEvents", AnimRenaultD320)

end

function AnimRenaultD320:onLoad(vehicle)	
	local spec = self.spec_AnimRenaultD320
	self.animridelleG = AnimRenaultD320.animridelleG
	self.animridelleD = AnimRenaultD320.animridelleD
	self.ridelleG = false
	self.ridelleD = false
	
	self.racine = I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.objet#index"));
	self.godetvisualpelle = I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.godetvisualpelle#index"));
end;

function AnimRenaultD320:onDelete() 	
end;

function AnimRenaultD320:onReadStream(streamId, connection)
    local ridelleG = streamReadBool(streamId)
    self:animridelleG(ridelleG, true)
	local ridelleD = streamReadBool(streamId)
    self:animridelleD(ridelleD, true)
end;
  
function AnimRenaultD320:onWriteStream(streamId, connection)
    streamWriteBool(streamId, self.ridelleG)
	streamWriteBool(streamId, self.ridelleD)
end;

function AnimRenaultD320:mouseEvent(posX, posY, isDown, isUp, button)
end;

function AnimRenaultD320:keyEvent(unicode, sym, modifier, isDown)    
end;

function AnimRenaultD320:onUpdate(dt, vehicle)
end;

function AnimRenaultD320:onUpdateTick() 
end;	
function AnimRenaultD320:onLeaveVehicle()
end;       
function AnimRenaultD320:onDraw() 
end;

function AnimRenaultD320:actionCallback(actionName, keyStatus, arg4, arg5, arg6)
	if keyStatus > 0 then
		if actionName == 'ridelle_G_RD320_v1' then
			if self.ridelleG then
				self:animridelleG(false)
			else 
				self:animridelleG(true)
			end
		end
		if actionName == 'ridelle_D_RD320_v1' then
			if self.ridelleD then
				self:animridelleD(false)
			else 
				self:animridelleD(true)
			end
		end	
	end
end

function AnimRenaultD320:animridelleG(ridelleG, noEventSend)
	AnimridelleGEvent.sendEvent(self, ridelleG, noEventSend)
	self.ridelleG = ridelleG;
	local spece = self.spec_motorized
	if spece.isMotorStarted then	
		if self.ridelleG then
			for name,_ in pairs(self.spec_animatedVehicle.animations) do
				self:playAnimation("ridelleG", 1, nil, true)
			end
		else
			for name,_ in pairs(self.spec_animatedVehicle.animations) do
				self:playAnimation("ridelleG", -1, nil, true)
			end
		end;
	end;
end;

function AnimRenaultD320:animridelleD(ridelleD, noEventSend)
	AnimridelleDEvent.sendEvent(self, ridelleD, noEventSend)
	self.ridelleD = ridelleD;
	if self.ridelleD then
		for name,_ in pairs(self.spec_animatedVehicle.animations) do
			self:playAnimation("ridelleD", 1, nil, true)
		end
	else
		for name,_ in pairs(self.spec_animatedVehicle.animations) do
			self:playAnimation("ridelleD", -1, nil, true)
		end
	end;
end;

--- Event ---

AnimridelleGEvent = {};
AnimridelleGEvent_mt = Class(AnimridelleGEvent, Event);
InitEventClass(AnimridelleGEvent, "AnimridelleGEvent");

function AnimridelleGEvent:emptyNew()
    local self = Event:new(AnimridelleGEvent_mt);
    return self;
end;
function AnimridelleGEvent:new(object, ridelleG)
	local self = AnimridelleGEvent:emptyNew()
	self.object = object;
	self.ridelleG = ridelleG;
	return self;
end;
function AnimridelleGEvent:readStream(streamId, connection)
	self.object = NetworkUtil.readNodeObject(streamId);
	self.ridelleG = streamReadBool(streamId);
	self:run(connection);
end;
function AnimridelleGEvent:writeStream(streamId, connection)
	NetworkUtil.writeNodeObject(streamId, self.object);
	streamWriteBool(streamId, self.ridelleG);
end;
function AnimridelleGEvent:run(connection)
	if not connection:getIsServer() then
		g_server:broadcastEvent(self, false, connection, self.object);
	end;
	if self.object ~= nil then
		self.object:animridelleG(self.ridelleG, true);
	end;
end;
function AnimridelleGEvent.sendEvent(vehicle, ridelleG, noEventSend)
	if ridelleG ~= vehicle.ridelleG then
		if noEventSend == nil or noEventSend == false then
			if g_server ~= nil then
				g_server:broadcastEvent(AnimridelleGEvent:new(vehicle, ridelleG), nil, nil, vehicle);
			else
				g_client:getServerConnection():sendEvent(AnimridelleGEvent:new(vehicle, ridelleG));
			end;
		end;
	end;
end;

AnimridelleDEvent = {};
AnimridelleDEvent_mt = Class(AnimridelleDEvent, Event);
InitEventClass(AnimridelleDEvent, "AnimridelleDEvent");

function AnimridelleDEvent:emptyNew()
    local self = Event:new(AnimridelleDEvent_mt);
    return self;
end;
function AnimridelleDEvent:new(object, ridelleD)
	local self = AnimridelleDEvent:emptyNew()
	self.object = object;
	self.ridelleD = ridelleD;
	return self;
end;
function AnimridelleDEvent:readStream(streamId, connection)
	self.object = NetworkUtil.readNodeObject(streamId);
	self.ridelleD = streamReadBool(streamId);
	self:run(connection);
end;
function AnimridelleDEvent:writeStream(streamId, connection)
	NetworkUtil.writeNodeObject(streamId, self.object);
	streamWriteBool(streamId, self.ridelleD);
end;
function AnimridelleDEvent:run(connection)
	if not connection:getIsServer() then
		g_server:broadcastEvent(self, false, connection, self.object);
	end;
	if self.object ~= nil then
		self.object:animridelleD(self.ridelleD, true);
	end;
end;
function AnimridelleDEvent.sendEvent(vehicle, ridelleD, noEventSend)
	if ridelleD ~= vehicle.ridelleD then
		if noEventSend == nil or noEventSend == false then
			if g_server ~= nil then
				g_server:broadcastEvent(AnimridelleDEvent:new(vehicle, ridelleD), nil, nil, vehicle);
			else
				g_client:getServerConnection():sendEvent(AnimridelleDEvent:new(vehicle, ridelleD));
			end;
		end;
	end;
end;